#!D:/IDE/anaconda3/envs/Microscope_Scan python
# -*- coding: UTF-8 -*-
"""
@FileName：StartScanningBusiness.py
@Description：
@Author：XSH
@Time：2025/12/2 17:49
@Department：研发部
@Copyright：©2025 乐辰生物
"""
from PyQt5 import Qt
from abc import abstractmethod, abstractclassmethod, abstractstaticmethod
from AppInterfaces.utils                    import *
from AppSettings.utils                      import *
from AppCore.Requests                       import *
from AppInterfaces.Interfaces               import *
from AppCore.Levels                         import *
from AppUtils.utils                         import *
from AppBackEnd.WebBusinessInterface import WebBusinessInterface


class StartScanningBusiness(Qt.QObject, WebBusinessInterface):
    def __init__(self, manager: WebReaderInterface = None, parent: Qt.QObject = None):
        super(StartScanningBusiness, self).__init__(parent=parent)
        self.Manager = manager
        self.Initialization("StartScanningBusiness", self, parent)

    def initWEBAPILevel(self):
        self.Level = WebAPILevel.startScan



    def Done(self, handler: WebClientInterface, **args):
        from AppCore.DBModels import CustomScanningModel
        isWrong: int = RECODE_FAILURE
        try:
            self.Handler = handler
            parameters: dict = {'isAuto': True}
            CustomScanningModel.initAutoScanCode()
            AppSlot.StartScanningSignal.emit(parameters)
            AppTimeLoop.processGlobalEvents(1000)
            isWrong = RECODE_SUCCEED
        except Exception as e:
            AppUtils.print_Exception(e)
        return

    def WaitDone(self, handler: WebClientInterface, **args) -> int:
        from AppCore.DBModels import CustomScanningModel
        isWrong: int = RECODE_FAILURE
        try:
            self.Handler = handler
            parameters: dict = {'isAuto': True}
            CustomScanningModel.initAutoScanCode()
            AppSlot.StartScanningSignal.emit(parameters)
            AppTimeLoop.processGlobalEvents(1000)
            isWrong = RECODE_SUCCEED
        except Exception as e:
            AppUtils.print_Exception(e)
        return isWrong











